SystemOrganization addCategory: #VMP!

Object subclass: #PersonManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

Object subclass: #ProjectVolunteer
	instanceVariableNames: 'tasks coordinators status schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
addCoordinator
	^ self! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
addTask
	^ self! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
removeCoordinator
	^ self! !

!ProjectVolunteer methodsFor: 'as yet unclassified' stamp: ''!
updateSatus
	^ self! !

Object subclass: #ProjectVolunteerManager
	instanceVariableNames: 'projects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
createProject
	^ self! !

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
queryProject
	^ self! !

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
removeProject
	^ self! !

!ProjectVolunteerManager methodsFor: 'as yet unclassified' stamp: ''!
validateVolunteer
	^ self! !

Object subclass: #Skill
	instanceVariableNames: 'skillId name description'
	classVariableNames: 'SkillDataBase'
	poolDictionaries: ''
	category: 'VMP'!

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
createSampleDatabase
	Transcript cr.
	Transcript show: '* creating database of skils'.
	Transcript cr.
	SkillDataBase := Dictionary new add: 1
					-> (self
							skillId: 1
							name: 'smallTalk language knowledge'
							description: '');
				 add: 2
					-> (self
							skillId: 2
							name: 'SUnit knowledge'
							description: '');
				 yourself! !

!Skill class methodsFor: 'as yet unclassified' stamp: ''!
skillId: t1 name: t2 description: t3 
	^ self new skillId: t1;
		 name: t2;
		 description: t3;
		 yourself! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
description
	^ description! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
description: t1 
	description := t1! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
skillId
	^ skillId! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
skillId: t1 
	skillId := t1! !

!Skill methodsFor: 'as yet unclassified' stamp: ''!
test_eve
	^ self! !

Object subclass: #Task
	instanceVariableNames: 'taskId name description status hours startDate completionDate deadline skills volunteers dependencies applicantsAccepted'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'VMP'!

!Task class methodsFor: 'as yet unclassified' stamp: ''!
addTask: newTask 
	self tasks add: newTask taskId -> newTask! !

!Task class methodsFor: 'as yet unclassified' stamp: ''!
createSampleDatabase
	Transcript cr.
	Transcript show: '* creating database of task'.
	Transcript cr.
	Database := Dictionary new add: 1
					-> (self
							taskId: 1
							name: 'Task 1'
							description: 'Description 1');
				 add: 2
					-> (self
							taskId: 2
							name: 'Task 2'
							description: 'Description 2');
				 add: 3
					-> (self
							taskId: 3
							name: 'Task 3'
							description: 'Description 3');
				 yourself! !

!Task class methodsFor: 'as yet unclassified' stamp: ''!
taskId: idInteger name: nameString description: descriptionString 
	^ self new taskId: idInteger;
		 name: nameString;
		 description: descriptionString;
		 yourself! !

!Task class methodsFor: 'as yet unclassified' stamp: ''!
tasks
	Database isNil
		ifTrue: [self createSampleDatabase].
	^ Database! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
acceptVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
acceptVolunteer: aVolunteer 
	volunteers add: aVolunteer volunteerId -> aVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addApplicantAccepted: aVolunteer 
	applicantsAccepted add: aVolunteer volunteerId -> aVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addDependency: aTask 
	dependencies add: aTask taskId -> aTask! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addSkill: aSkill 
	skills add: aSkill skillId -> aSkill! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addSkill: key and: aSkill 
	skills add: key -> aSkill! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
addVolunteer: aVolunteer 
	volunteers add: aVolunteer volunteerId -> aVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
applicantsAccepted
	^ applicantsAccepted! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
applicantsAccepted: newApplicantsAccepted 
	applicantsAccepted := newApplicantsAccepted! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
completionDate
	^ completionDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
completionDate: newCompletionDate 
	completionDate := newCompletionDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
deadline
	^ deadline! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
deadline: newDeadLine 
	deadline := newDeadLine! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
dependencies
	^ dependencies! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
dependencies: newDependencies 
	dependencies := newDependencies! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
description
	^ description! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
description: newDescription 
	description := newDescription! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
fibonacci
	^ self <= 2
		ifTrue: [1]
		ifFalse: [(self - 1) fibonacci + (self - 2) fibonacci]! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
getSizeSkills
	^ skills size! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
hours
	^ hours! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
hours: newHours 
	hours := newHours! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
initialize
	skills := Dictionary new.
	dependencies := Dictionary new.
	volunteers := Dictionary new.
	applicantsAccepted := Dictionary new! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
name: newName 
	name := newName! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
rejectVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
rejectVolunteer: idVolunteer 
	'delete of list applicants voluntee' applicants removeKey: idVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
removeVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
removeVolunteer: idVolunteer 
	volunteers removeKey: idVolunteer! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
skills
	^ skills! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
skills: newSkills 
	skills := newSkills! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
start
	startDate := Date now! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
startDate
	^ startDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
startDate: newStartDate 
	startDate := newStartDate! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
status
	^ status! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
status: newStatus 
	status := newStatus! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
suggestVolunteer
	^ self! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
taskId
	^ taskId! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
taskId: Id 
	taskId := Id! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
terminate
	completionDate = Date new! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
volunteers
	^ volunteers! !

!Task methodsFor: 'as yet unclassified' stamp: ''!
volunteers: newVolunteers 
	volunteers := newVolunteers! !

Object subclass: #TaskManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
createTask
	^ self! !

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
queryTask
	^ self! !

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
removeTask
	^ self! !

!TaskManager methodsFor: 'as yet unclassified' stamp: ''!
suggestVolunteerTask
	^ self! !

Object subclass: #VMP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

Object subclass: #Volunteer
	instanceVariableNames: 'volunteerId name age gender skills email currentTasks'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'VMP'!

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
addVolunteer: t1 
	self volunteers add: t1! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
createSampleDatabase
	Transcript cr.
	Transcript show: '* creating database of volunteers firstTime'.
	Transcript cr.
	Database := Dictionary new add: 1
					-> (self
							volunteerId: 1
							name: 'Evelyn Perez Cervantes'
							email: 'epcervantes7@gmail.com');
				 add: 2
					-> (self
							volunteerId: 2
							name: 'Nataly Perez Cervantes'
							email: 'natalypc2@gmail.com');
				 add: 3
					-> (self
							volunteerId: 3
							name: 'Sidney Perez Cervantes'
							email: 'sidneypc27@gmail.com');
				 yourself! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
listOfVolunteers
	| t1 |
	1
		to: self volunteers size
		do: [:t2 | 
			t1 := t1 + t2.
			Transcript show: self volunteers at: t2]! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
name: t1 email: t2 age: t3 
	^ self new name: t1;
		 email: t2;
		 age: t3;
		 yourself! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
volunteerId: idInteger name: nameString email: emailString 
	^ self new volunteerId: idInteger;
		 name: nameString;
		 email: emailString;
		 skills: Dictionary new;
		 yourself! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
volunteerId: aninteger name: t2 email: t3 age: t4 
	^ self new volunteerId: aninteger;
		 name: t2;
		 email: t3;
		 age: t4;
		 yourself! !

!Volunteer class methodsFor: 'as yet unclassified' stamp: ''!
volunteers
	Database isNil
		ifTrue: [self createSampleDatabase].
	^ Database! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
addSkillToVolunteer: anSkill 
	self skills add: anSkill skillId -> anSkill! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
age
	^ age! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
age: t1 
	name := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
currentTasks
	^ currentTasks! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
email
	^ email! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
email: t1 
	email := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
gender
	^ gender! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
gender: t1 
	gender := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
name
	^ name! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
name: t1 
	name := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
removeSkillOfVolunteer: anInteger 
	self skills removeKey: anInteger! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
skills
	^ skills! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
skills: t1 
	skills := t1! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
volunteerId
	^ volunteerId! !

!Volunteer methodsFor: 'as yet unclassified' stamp: ''!
volunteerId: t1 
	volunteerId := t1! !

TestCase subclass: #MySetTest
	instanceVariableNames: 'full empty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VMP'!

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
setUp
	Contact createSampleDatabase.
	empty := Set new.
	full := Set with: 5 with: #abc! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testAddTask
	| task1 isTrue |
	task1 := Task new.
	task1 taskId: 4.
	task1 name: 'Task Test'.
	task1 description: 'Description Test'.
	Task addTask: task1.
	isTrue := Task tasks includes: task1.
	self assert: isTrue! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testIncludes
	self
		assert: (full includes: 5).
	self
		assert: (full includes: #abc)! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testOccurrences
	self assert: (empty occurrencesOf: 0)
			= 0.
	self assert: (full occurrencesOf: 5)
			= 1.
	full add: 5.
	self assert: (full occurrencesOf: 5)
			= 1! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testRemove
	full remove: 5.
	self
		assert: (full includes: #abc).
	self
		deny: (full includes: 5)! !

!MySetTest methodsFor: 'as yet unclassified' stamp: ''!
testaddVolunteer
	| t1 t2 |
	t1 := Volunteer new.
	t1 name: 'Juan Perez'.
	Volunteer addVolunteer: t1.
	t2 := Volunteer volunteers includes: t1.
	self assert: t2! !
